{
    Файл является частью библиотеки RubiRobot

    © 2017-2018 Слинкин Д.А.

    Класс монохромного изображения с экспортом-импортом на fb-устройство
    Используется для поддержки дисплея контроллера Lego EV3

    Подробная информация о лицензировании находится в файле README,
    входящем в состав библиотеки.

    ДАННОЕ ПРОГРАММНОЕ ОБЕСПЕЧЕНИЕ ПРЕДОСТАВЛЯЕТСЯ «КАК ЕСТЬ», БЕЗ
    КАКИХ-ЛИБО ГАРАНТИЙ, ЯВНО ВЫРАЖЕННЫХ ИЛИ ПОДРАЗУМЕВАЕМЫХ,
    ВКЛЮЧАЯ ГАРАНТИИ ТОВАРНОЙ ПРИГОДНОСТИ, СООТВЕТСТВИЯ ПО ЕГО
    КОНКРЕТНОМУ НАЗНАЧЕНИЮ И ОТСУТСТВИЯ НАРУШЕНИЙ, НО НЕ ОГРАНИЧИВАЯСЬ 
    ИМИ. НИ В КАКОМ СЛУЧАЕ АВТОРЫ ИЛИ ПРАВООБЛАДАТЕЛИ НЕ НЕСУТ
    ОТВЕТСТВЕННОСТИ ПО КАКИМ-ЛИБО ИСКАМ, ЗА УЩЕРБ ИЛИ ПО ИНЫМ ТРЕБОВАНИЯМ,
    В ТОМ ЧИСЛЕ, ПРИ ДЕЙСТВИИ КОНТРАКТА, ДЕЛИКТЕ ИЛИ ИНОЙ СИТУАЦИИ,
    ВОЗНИКШИМ ИЗ-ЗА ИСПОЛЬЗОВАНИЯ ПРОГРАММНОГО ОБЕСПЕЧЕНИЯ ИЛИ ИНЫХ
    ДЕЙСТВИЙ С ПРОГРАММНЫМ ОБЕСПЕЧЕНИЕМ.

 **********************************************************************}
{$SMARTLINK ON} 
{$mode objfpc}
unit uev3image;
interface
uses uev3const,fpimage;

const
  ev3BlackColor:TFPColor = (red:$ffff;green:$ffff;blue:$ffff;alpha:$ffff);
  ev3WhiteColor:TFPColor = (red:0;green:0;blue:0;alpha:$ffff);
  ev3Width=178;
  ev3MaxWidth=192;
  ev3Height=128;
  ev3bpl=24;
  ev3Cbpl=712;
  { TEv3Image }
type
  TEv3fbmem=array[0..ev3Height-1,0..ev3bpl-1]of byte;
  TEv3Cfbmem=array[0..ev3Height-1,0..ev3Cbpl-1]of byte;
  TEv3Image=class(TFPCustomImage)
    private
      Finverse: boolean;
      FColor:boolean;
      fMem:array[0..ev3Height-1,0..ev3MaxWidth-1]of byte;
      procedure Setinverse(AValue: boolean);
    protected
      function GetInternalColor(x,y:integer):TFPColor;override;
      procedure SetInternalColor (x,y:integer; const Value:TFPColor);override;
      procedure SetUsePalette (Value:boolean);override;
      procedure SetInternalPixel (x,y:integer; Value:integer); override;
      function GetInternalPixel (x,y:integer) : integer; override;
    public
      constructor create (AWidth,AHeight:integer); override;
      constructor create ();overload;
      destructor destroy; override;
      procedure setVisual(Color:boolean);
      procedure SetSize (AWidth, AHeight : integer); override;
      procedure clear();
      procedure exportFB(var fbmem);
      procedure importFB(const fbmem);
      property inverse:boolean read Finverse write Setinverse;
  end;

implementation
{ TEv3Image }

procedure TEv3Image.clear();
begin
 fillbyte(fmem,sizeof(fmem),0);
end;

procedure TEv3Image.Setinverse(AValue: boolean);
begin
  if Finverse=AValue then Exit;
  Finverse:=AValue;
end;

function TEv3Image.GetInternalColor(x, y: integer): TFPColor;
begin
  if GetInternalPixel(x, y)=(ev3Black xor ord(finverse)) then result:=ev3BlackColor
  else result:=ev3WhiteColor;
end;

procedure TEv3Image.SetInternalColor(x, y: integer; const Value: TFPColor);
begin
//  writeln(x,' ',y,' ',value.red,' ',value.green,' ',value.blue,' ',value.alpha);
  if value=ev3whiteColor then SetInternalPixel(x, y, (ev3White xor ord(finverse)))
  else SetInternalPixel(x, y, (ev3Black xor ord(finverse)))
end;

procedure TEv3Image.SetUsePalette(Value: boolean);
begin
  inherited SetUsePalette(false);
end;

procedure TEv3Image.SetInternalPixel(x, y: integer; Value: integer);
begin
  if (x<0)or(x>=ev3MaxWidth)or(y<0)or(y>=ev3Height) then exit;
  fMem[y,x]:=value;
end;

function TEv3Image.GetInternalPixel(x, y: integer): integer;
begin
  if (x<0)or(x>=ev3MaxWidth)or(y<0)or(y>=ev3Height) then begin result:=0; exit; end;
  result:=fMem[y,x];
end;

constructor TEv3Image.create(AWidth, AHeight: integer);
begin
  inherited create(ev3Width, ev3Height);
end;

constructor TEv3Image.create();
begin
  inherited create(ev3Width, ev3Height);
end;


destructor TEv3Image.destroy;
begin
  inherited destroy;
end;

procedure TEv3Image.setVisual(Color: boolean);
begin
  FColor:=color;
end;

procedure TEv3Image.SetSize(AWidth, AHeight: integer);
begin
  inherited SetSize(ev3MaxWidth, ev3Height);
end;

var
 ev3BlackA:array[0..3]of byte=(255,255,255,255);
 ev3WhiteA:array[0..3]of byte=(0,0,0,255);

procedure TEv3Image.exportFB(var fbmem);
 var m:Tev3fbmem absolute fbmem;
//     mc:Tev3Cfbmem absolute fbmem;
     p:pbyte; i,j:integer;
begin
 if not fColor then begin
  p:=@fmem;
  for i:=0 to ev3Height-1 do begin
   for j:=0 to ev3bpl-1 do begin
      m[i,j]:=p[0] or (p[1] shl 1) or (p[2] shl 2) or (p[3] shl 3) or (p[4] shl 4)
                   or (p[5] shl 5) or (p[6] shl 6) or (p[7] shl 7);
      inc(p,8);
   end;
  end;
 end
 else begin
   p:=@fbmem;
   for i:=0 to ev3Height-1 do begin
    for j:=0 to ev3Width-1 do begin
      if fmem[i,j]=0 then move(ev3BlackA,p^,4)
      else move(ev3WhiteA,p^,4);
      inc(p,4);
    end;
   end;
 end;
end;

procedure TEv3Image.importFB(const fbmem);
 var m:Tev3fbmem absolute fbmem;
     p:pbyte; b:byte; i,j:integer;
begin
 if not fColor then begin
  p:=@fmem;
  for i:=0 to ev3Height-1 do begin
   for j:=0 to ev3bpl-1 do begin
	b:=m[i,j];
	p[0]:=b and 1;
	p[1]:=(b shr 1) and 1;
	p[2]:=(b shr 2) and 1;
	p[3]:=(b shr 3) and 1;
	p[4]:=(b shr 4) and 1;
	p[5]:=(b shr 5) and 1;
	p[6]:=(b shr 6) and 1;
	p[7]:=(b shr 7) and 1;
      inc(p,8);
   end;
  end;
 end else begin
  p:=@fbmem;
  for i:=0 to ev3Height-1 do begin
   for j:=0 to ev3Width-1 do begin
     fmem[i,j]:=not (p[0] or p[1] or p[2]);
     inc(p,4);
   end;
  end;
 end;
end;

end.

